<?php
/******************
 * 
 * ContactPage
 * 
 * Tutorial on www.ssbits.com/creating-a-simple-contact-form/
 * 
 * Author: Aram Balakjian of aabweb.co.uk
 * 
 ******************/

//Model
class ContactPage extends Page
{
	static $db = array(
		'Mailto' => 'Varchar(100)', //Email address to send submissions to
		'SubmitText' => 'HTMLText' //Text presented after submitting message
	);
	
	
	//One to many relationship with Contact object
	  public static $has_many = array(
	    'ContactSubmissions' => 'ContactSubmission'
	  );
	  
	  
	//CMS fields
	function getCMSFields() 
	{
		$fields = parent::getCMSFields();
	
		$fields->addFieldToTab("Root.OnSubmission", new TextField('Mailto', 'Email submissions to'));	
		$fields->addFieldToTab("Root.OnSubmission", new HTMLEditorField('SubmitText', 'Text on Submission'));
		
			
			// Create Grid Field
			//public function getCMSFields() {
			// $fields = parent::getCMSFields();
			  
			  $gridFieldConfig = GridFieldConfig::create()->addComponents(
			    new GridFieldToolbarHeader(),
			    //new GridFieldAddNewButton('toolbar-header-right'),
			    new GridFieldSortableHeader(),
			    new GridFieldDataColumns(),
			    new GridFieldPaginator(10),
			   // new GridFieldEditButton(),
			    new GridFieldDeleteAction(),
			    new GridFieldDetailForm()
			  );
			  
			  $gridField = new GridField("ContactSubmissions", "Submission list:", $this->ContactSubmissions(), $gridFieldConfig);
			  
			  
			    return $fields;
			 // $gridField->setDisplayFields(array(
			  	//		'ID' => 'ID',
			  	//		'Title' => 'Title of the Photo',
			  	//		'Image.URL' => 'Image URL',		
			  	//	));	
			  		
			  		
			  $fields->addFieldToTab("Root.Submissions", $gridField);
			  
			  //return $fields;
			//}
			
			
	
		return $fields;	
	}

}

// Controller
class ContactPage_Controller extends Page_Controller
{
	//Define our form function as allowed
	static $allowed_actions = array(
		'ContactForm'
	);
	
	//The function which generates our form
	function ContactForm() 
	{
      	// Create fields
	    $fields = new FieldList(
	
		DropdownField::create("Prefix","Title")
		      ->setSource(array('Mr.' => 'Mr.', 'Ms.' => 'Ms.', 'Mrs.' => 'Mrs.', 'Dr.' => 'Dr.', 'Rev.' => 'Rev.')), 
	   TextField::create("FirstName")->setTitle('Firstname'),
	   TextField::create("Surname")->setTitle('Surname')->setMaxLength(50),
	   
	   TextField::create("DaytimeTel")->setTitle('Daytime Contact Number'),
	   TextField::create("EveningTel")->setTitle('Evening / Weekend Contact Number'),
		new EmailField('Email', 'Email*'),
		new TextareaField('Comments','Enquiry*')
		);
	 	
	    // Create action
	    $actions = new FieldList(
	  	FormAction::create('SendContactForm', 'Send')
	      ->setStyle("primary")
	    );
		
		// Create validation
		$validator = new RequiredFields('Prefix','FirstName', 'Surname', 'Email', 'Comments');
		
		//return form fields,actions, validation
	   $cform = BootstrapForm::create($this, 'ContactForm', $fields, $actions, $validator)->addWell()
	    ->setLayout("horizontal");
	    
	    // form fields and mollom fields mapping
	    
	    //'session_id' => '',
	    //'post_title' => '',
	    //'post_body' => '',
	   // 'author_name' => '', 
	   // 'author_url' => '',
	   // 'author_mail' => '',
	   // 'author_openid' => '',
	   // 'author_id' => ''


	    
	    $fieldMap = array('Prefix' => 'Prefix', 'FirstName' => 'author_name', 'Surname' => 'author_name', 'Email' => 'author_mail', 'DaytimeTel' => 'DaytimeTel', 'EveningTel' => 'EveningTel','Comments' => 'post_body');
	    
	    // Update the form to add the protector field to it
	    $protector = SpamProtectorManager::update_form($cform, null, $fieldMap);
	    return $cform;
	
	}
 	
	//The function that handles our form submission
	function SendContactForm($data, $form) 
	{
	
	$DataContactSubmission = new ContactSubmission();

     

//echo "<p>email: " . $DataContactSubmission->getField('Email') . "</p>";
//	die ('<pre>' . print_r($DataContactSubmission, true) . '</pre>');
       $form->saveInto($DataContactSubmission);
        //$form->saveInto($Member);           
       //why do i need this but dont on other example
      // $DataContactSubmission->write();
        //$Member->login();
  if ($DataContactSubmission->write()) {      
        
        
	 	//Set data
		$From = $data['Email'];
		$To = $this->Mailto;
		$Subject = "HMY: Website Contact message";  	  
		$email = new Email($From, $To, $Subject);
		//set template
		$email->setTemplate('ContactEmail');
		//populate template
		$email->populateTemplate($data);
		//send mail
		$email->send();
		
		} else {
			$form->sessionMessage(_t('VALUATION_REQUEST_SUBMIT_ERROR', 'There was an error'), 'error');
		}
		
	  	//return to submitted message
		Director::redirect(Director::baseURL(). $this->URLSegment . "/?success=1");

return;
	}

	//The function to test whether to display the Submit Text or not
	public function Success()
	{
		return isset($_REQUEST['success']) && $_REQUEST['success'] == "1";
	}
	
	
	
	
	
	
	
	
		
	
	public function init() {
		parent::init();
		
	//Requirements::block('reset');
	
		//Requirements::block('themes/hmy/css/reset.css');
		//Requirements::block('themes/hmy/css/form.css');
	
	//Requirements::block()
	//Requirements::themedCSS('form');
	
	}
	
	
	
	
	
	
	
}